Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 2528)
@@ -29,4 +29,5 @@
    USE mod_prism_put_proto          ! OASIS3 prism module for snding
    USE mod_prism_get_proto          ! OASIS3 prism module for receiving
+   USE mod_comprism_proto           ! OASIS3 prism module to get coupling frequency
    USE par_oce                      ! ocean parameters
    USE dom_oce                      ! ocean space and time domain
@@ -61,10 +62,11 @@
    PUBLIC cpl_prism_snd
    PUBLIC cpl_prism_rcv
+   PUBLIC cpl_prism_freq
    PUBLIC cpl_prism_finalize
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Header$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -210,5 +212,5 @@
       !! * Arguments
       !!
-      INTEGER,                      INTENT( IN    )   :: kid       ! variable intex in the array
+      INTEGER,                      INTENT( IN    )   :: kid       ! variable index in the array
       INTEGER,                      INTENT(   OUT )   :: kinfo     ! OASIS3 info argument
       INTEGER,                      INTENT( IN    )   :: kstep     ! ocean time-step in seconds
@@ -247,5 +249,5 @@
       !!      like stresses and fluxes from the coupler or remote application.
       !!----------------------------------------------------------------------
-      INTEGER,                      INTENT( IN    )   :: kid       ! variable intex in the array
+      INTEGER,                      INTENT( IN    )   :: kid       ! variable index in the array
       INTEGER,                      INTENT( IN    )   :: kstep     ! ocean time-step in seconds
       REAL(wp), DIMENSION(jpi,jpj), INTENT( INOUT )   :: pdata     ! IN to keep the value if nothing is done
@@ -293,4 +295,18 @@
 
 
+   FUNCTION cpl_prism_freq( kid )  
+
+      !!---------------------------------------------------------------------
+      !!              ***  ROUTINE cpl_prism_freq  ***
+      !!
+      !! ** Purpose : - send back the coupling frequency for a particular field
+      !!----------------------------------------------------------------------
+      INTEGER,INTENT( IN )   :: kid              ! variable index 
+      INTEGER                :: cpl_prism_freq   ! coupling frequency
+      cpl_prism_freq = ig_def_freq( kid )
+
+   END FUNCTION cpl_prism_freq
+
+
    SUBROUTINE cpl_prism_finalize
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90	(revision 2528)
@@ -1,7 +1,6 @@
 MODULE cpl_oasis4
    !!======================================================================
-   !!                    ***  MODULE cpl_oasis4  ***
+   !!                    ***  MODULE cpl_oasis  ***
    !! Coupled O/A : coupled ocean-atmosphere case using OASIS4
-   !!               special case: OPA/LIM coupled to ECHAM5
    !!=====================================================================
    !! History :   
@@ -11,113 +10,65 @@
    !!   " "  !  05-08  (R. Redler, W. Park) frld initialization, paral(2) revision
    !!   " "  !  05-09  (R. Redler) extended to allow for communication over root only
-   !!   " "  !  05-09  (R. Redler) extended to allow for communication over root only
-   !!   " "  !  05-12  (R. Hill, Met. Office) Tweaks and hacks to get NEMO/O4 working
-   !!   " "  !  06-02  (R. Redler, W. Park) Bug fixes and updates according to the OASIS3 interface
-   !!   " "  !  06-02  (R. Redler) app/grid/grid_name from namelist
+   !!   " "  !  06-01  (W. Park) modification of physical part
+   !!   " "  !  06-02  (R. Redler, W. Park) buffer array fix for root exchange
+   !!   " "  !  2010   (E. Maisonnave and S. Masson) complete rewrite
    !!----------------------------------------------------------------------
 #if defined key_oasis4
    !!----------------------------------------------------------------------
    !!   'key_oasis4'                    coupled Ocean/Atmosphere via OASIS4
+   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   cpl_prism_init     : initialization of coupled mode communication
    !!   cpl_prism_define   : definition of grid and fields
-   !!   cpl_prism_send     : send out fields in coupled mode
-   !!   cpl_prism_recv     : receive fields in coupled mode
+   !!   cpl_prism_snd     : snd out fields in coupled mode
+   !!   cpl_prism_rcv     : receive fields in coupled mode
+   !!   cpl_prism_update_time   : update date sent to Oasis
    !!   cpl_prism_finalize : finalize the coupled mode communication
    !!----------------------------------------------------------------------
-   !! * Modules used
-!##################### WARNING coupled mode ###############################
-!##################### WARNING coupled mode ###############################
-!   Following line must be enabled if coupling with OASIS
-!   USE prism                        ! prism module
-!##################### WARNING coupled mode ###############################
-!##################### WARNING coupled mode ###############################
-#if defined key_mpp_mpi
-   USE lib_mpp, only : mppsize, mpprank   ! message passing
-   USE lib_mpp, only : mppsend            ! message passing
-   USE lib_mpp, only : mpprecv            ! message passing
-#endif
+   USE prism              ! OASIS4 prism module
+   USE par_oce                      ! ocean parameters
    USE dom_oce                      ! ocean space and time domain
+   USE domwri                       ! ocean space and time domain
    USE in_out_manager               ! I/O manager
-   USE par_oce                      !
-   USE phycst, only : rt0           ! freezing point of sea water
-   USE oasis4_date                  ! OASIS4 date declarations in
-                                    ! PRISM compatible format
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+
    IMPLICIT NONE
+   PRIVATE
 !
-! Exchange parameters for coupling ORCA-LIM with ECHAM5
-!
-#if defined key_cpl_ocevel
-   INTEGER, PARAMETER         :: nsend =  6
-#else
-   INTEGER, PARAMETER         :: nsend =  4
-#endif
-
-#if defined key_cpl_discharge
-   INTEGER, PARAMETER         :: nrecv = 20
-#else
-   INTEGER, PARAMETER         :: nrecv = 17
-#endif
-
-   INTEGER, DIMENSION(nsend)  :: send_id
-   INTEGER, DIMENSION(nrecv)  :: recv_id
-
-   CHARACTER(len=32)          :: cpl_send (nsend)
-   CHARACTER(len=32)          :: cpl_recv (nrecv)
-
-   CHARACTER(len=16)          :: app_name       ! application name for OASIS use
-   CHARACTER(len=16)          :: comp_name      ! name of this PRISM component
-   CHARACTER(len=16)          :: grid_name      ! name of the grid
-   CHARACTER(len=1)           :: c_mpi_send
-
-! The following now come in via new module oasis4_date
-!   TYPE(PRISM_Time_struct), PUBLIC    :: dates          ! date info for send operation
-!   TYPE(PRISM_Time_struct), PUBLIC    :: dates_bound(2) ! date info for send operation
-!   TYPE(PRISM_Time_struct), PUBLIC    :: dater          ! date info for receive operation
-!   TYPE(PRISM_Time_struct), PUBLIC    :: dater_bound(2) ! date info for receive operation
-!   TYPE(PRISM_Time_struct), PUBLIC    :: tmpdate
-
-   PRIVATE
-
-   INTEGER, PARAMETER         :: localRoot  = 0
-
-   INTEGER                    :: localRank      ! local MPI rank
-   INTEGER                    :: localSize      ! local MPI size
-   INTEGER                    :: localComm      ! local MPI size
-   LOGICAL                    :: commRank       ! true for ranks doing OASIS communication
-   INTEGER                    :: comp_id        ! id returned by prism_init_comp
-
-   INTEGER                    :: range(5)
-
-   LOGICAL, SAVE              :: prism_was_initialized
-   LOGICAL, SAVE              :: prism_was_terminated
-   INTEGER, SAVE              :: write_grid
-
-   INTEGER                    :: ierror         ! return error code
-
-#ifdef key_cpl_rootexchg
-   LOGICAL                               :: rootexchg =.true.     ! logical switch 
-#else
-   LOGICAL                               :: rootexchg =.false.    ! logical switch
-#endif
-
-   REAL(wp), DIMENSION(:,:), ALLOCATABLE :: exfld  ! Temporary buffer for exchange
-   REAL(wp), DIMENSION(:),   ALLOCATABLE :: buffer ! Temporary buffer for exchange
-   INTEGER, DIMENSION(:,:),  ALLOCATABLE :: ranges ! Temporary buffer for exchange
-
-   DOUBLE PRECISION           :: date_incr
+!   LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .TRUE.    ! coupled flag
+   INTEGER                    :: ncomp_id           ! id returned by prism_init_comp
+   INTEGER                    :: nerror             ! return error code
+   INTEGER, PUBLIC            :: OASIS_Rcv  = 1     ! return code if received field
+   INTEGER, PUBLIC            :: OASIS_idle = 0     ! return code if nothing done by oasis
+
+   INTEGER, PARAMETER :: nmaxfld=40    ! Maximum number of coupling fields
+   
+   TYPE, PUBLIC ::   FLD_CPL            ! Type for coupling field information
+      LOGICAL            ::   laction   ! To be coupled or not
+      CHARACTER(len = 8) ::   clname    ! Name of the coupling field   
+      CHARACTER(len = 1) ::   clgrid    ! Grid type  
+      REAL(wp)           ::   nsgn      ! Control of the sign change
+      INTEGER            ::   nid       ! Id of the field
+   END TYPE FLD_CPL
+
+   TYPE(FLD_CPL), DIMENSION(nmaxfld), PUBLIC :: srcv, ssnd   ! Coupling fields
+
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: exfld  ! Temporary buffer for receiving
+
+   TYPE(PRISM_Time_struct), PUBLIC    :: date            ! date info for send operation
+   TYPE(PRISM_Time_struct), PUBLIC    :: date_bound(2)   ! date info for send operation
+
 
    !! Routine accessibility
    PUBLIC cpl_prism_init
    PUBLIC cpl_prism_define
-   PUBLIC cpl_prism_send
-   PUBLIC cpl_prism_recv
+   PUBLIC cpl_prism_snd
+   PUBLIC cpl_prism_rcv
+   PUBLIC cpl_prism_update_time
    PUBLIC cpl_prism_finalize
 
-   PUBLIC send_id, recv_id
-
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Id$
+   !! $Header$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -125,7 +76,5 @@
 CONTAINS
 
-   SUBROUTINE cpl_prism_init( localCommunicator )
-
-      IMPLICIT NONE
+   SUBROUTINE cpl_prism_init (kl_comm) 
 
       !!-------------------------------------------------------------------
@@ -137,111 +86,20 @@
       !! ** Method  :   OASIS4 MPI communication 
       !!--------------------------------------------------------------------
-      !! * Arguments
-      !!
-      INTEGER, INTENT(OUT)       :: localCommunicator
-      !!
-      !! * Local declarations
-      !!
-
-      NAMELIST/nam_mpp/ app_name, comp_name, c_mpi_send, grid_name
-
-      !!
-      !!--------------------------------------------------------------------
-      !!
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'cpl_prism_init : initialization in coupled ocean/atmosphere case'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~'
-      IF(lwp) WRITE(numout,*)
-     
-#if defined key_flx_bulk_monthly || defined key_flx_bulk_daily || defined key_flx_forced_daily
-
-#if !defined key_oasis4
-! The following is not necessarily a valid peice of checking
-
-      IF(lwp) WRITE(numout,cform_err)
-      IF(lwp) WRITE(numout,*) ' key_coupled and key_flx_bulk_* key_flx_forced_daily are incompatible'
-      nstop = nstop + 1
-
-#endif
-
-#endif
-
-      REWIND( numnam )
-      READ  ( numnam, nam_mpp )
-      REWIND( numnam )
-
-      !------------------------------------------------------------------
-      ! 1st Initialize the PRISM system for the application
-      !------------------------------------------------------------------
-
-      CALL prism_initialized (prism_was_initialized, ierror)
-      IF ( ierror /= PRISM_Success ) &
-         CALL prism_abort( comp_id, 'OPA9.0', 'cpl_prism_init: Failure in prism_initialized' )
-
-      IF ( .NOT. prism_was_initialized ) THEN
-         CALL prism_init( app_name, ierror )
-         IF ( ierror /= PRISM_Success ) &
-            CALL prism_abort(comp_id, 'OPA9.0', 'cpl_prism_init: Failure in prism_init')
-         prism_was_initialized = .true.
-      ELSE
-         call prism_abort(comp_id, 'OPA9.0', 'cpl_prism_init: Do not initialize prism twice!')
-      ENDIF
-      !
-      ! Obtain the actual dates and date bounds
-      !
-      ! date is determined by adding days since beginning of
-      !   the run to the corresponding initial date. Note that
-      !   OPA internal info about the start date of the experiment
-      !   is bypassed. Instead we rely sololy on the info provided
-      !   by the SCC.xml file. 
-      !
-      dates   = PRISM_Jobstart_date
-
-      WRITE(6,*) "PRISM JOB START DATE IS", dates
-
-      !
-      ! upper bound is determined by adding half a time step
-      !
-      tmpdate = dates
-      date_incr = rdttra(1)/2.0
-      CALL PRISM_calc_newdate ( tmpdate, date_incr, ierror )
-      dates_bound(2) = tmpdate
-      !
-      ! lower bound is determined by half distance to date from previous run
-      !
-      tmpdate   = dates
-      date_incr = ( adatrj - adatrj0 ) * 43200.0
-      CALL PRISM_calc_newdate ( tmpdate, date_incr, ierror )
-      dates_bound(1) = tmpdate
-
-      dater = dates
-      dater_bound(1) = dates_bound(1) 
-      dater_bound(2) = dates_bound(2) 
-
-      WRITE(6,*) "DATE send and rec BOUNDS",dater_bound
-      WRITE(6,*) "OTHER BITS FOR DATE",rdttra(1)
-      WRITE(6,*) "adatrj/0",adatrj,adatrj0,date_incr
+      INTEGER, INTENT(   OUT )   :: kl_comm       ! local communicator of the model
+      !
+      
+      CALL prism_init( 'nemo', nerror )
 
       !------------------------------------------------------------------
       ! 2nd Initialize the PRISM system for the component
       !------------------------------------------------------------------
-
-      CALL prism_init_comp ( comp_id, comp_name, ierror )
-      IF ( ierror /= PRISM_Success ) &
-         CALL prism_abort (comp_id, 'OPA9.0', 'cpl_prism_init: Failure in prism_init_comp')
-
-      WRITE(6,*) "COMPLETED INIT_COMP",comp_name,comp_id
-
-      !------------------------------------------------------------------
-      ! 3rd Get an MPI communicator for OPA local communication
-      !------------------------------------------------------------------
-
-      CALL prism_get_localcomm ( comp_id, localComm, ierror )
-      IF ( ierror /= PRISM_Success ) &
-         CALL prism_abort (comp_id, 'OPA9.0', 'cpl_prism_init: Failure in prism_get_localcomm' )
-
-      localCommunicator = localComm
-
-       WRITE(6,*) "COMPLETED GET_LOCALCOMM",comp_name,comp_id
+      CALL prism_init_comp( ncomp_id, 'oceanx', nerror )
+      IF( nerror /= PRISM_Success )   CALL prism_abort( ncomp_id, 'cpl_prism_init', 'Failure in prism_init_comp' )
+
+      !------------------------------------------------------------------
+      ! 3rd Get an MPI communicator fr OPA local communication
+      !------------------------------------------------------------------
+      CALL prism_get_localcomm( ncomp_id, kl_comm, nerror )
+      IF( nerror /= PRISM_Success )   CALL prism_abort( ncomp_id, 'cpl_prism_init', 'Failure in prism_get_localcomm' )
 
 
@@ -249,7 +107,5 @@
 
 
-   SUBROUTINE cpl_prism_define ()
-
-      IMPLICIT NONE
+   SUBROUTINE cpl_prism_define (krcv, ksnd)
 
       !!-------------------------------------------------------------------
